# Usage

## Initial setup

CRFs are always part of a study. So, create study as you would normally do, keep subject
identifier to ParticipantId, which is the default.

Once you do, you should enable CRF module. 
See [LabKey documentation][labkeyEnableModule] on how to enable a module.

In Study setup, select Edit additional properties. New fields should be:
- EudraCTNumber,
- StudySponsor,
- StudyCoordinator,
- RegulatoryNumber,
all as strings. It should look like this

![Alt text][studyParameters]


The initial set of setup lists is part of the distribution. Copy 
[archive][listArchive] locally 
and import list archive to Labkey in the study. You will get list of lists by
clicking on setup wheel at the top of the screen and selecting Manage lists.

Create demographicData dataset as part of the study. It can have no fields.

## Setting up a form

### Datasets

Create a dataset as a list. Go to Wheel->Manage Lists and Create List. Setup fields as you would normally do. 
Three additional fields are required:

- participantCode (String)
- submissionDate (DateTime)
- crfRef (String)

[Here][exampleList] is an example included with the list archive. 

Open the inputLists list and add the name of the new list as a new entry. The sample
dataset is already there.

### Forms
CRF consists of a series of forms, contained in the Forms list.
Each form is a logical assembly of datasets. Each form has a setup, which is a 
list which specifies which datasets are part of the form, and a title. 
The only programatical feature that a form has is that all its datasets 
should be completed before the form is submitted for review. 
Each form can be reviewed independently.

Some fields are set to default values for historical reasons:

- formUrl: visit0
- reviewFormUrl: reviewVisit0
- viewURL: visit0.view

The last field, master query is to be set to the created dataset list. Each form 
has a master query that contains
a participantCode field, and that is the field that will be used as the participant 
assignment field for all datasets in the form. The
sample Forms list already has an entry for demographicsData dataset.

### Form setup

A form setup is a list of datasets in the form and contains the following fields:

![setup list][setupList]

For a new setup list entry, set Query Name to the dataset name with Title that can be any string. 
Other fields are set to NONE by default.

![setup list example with NONE][setupListExample1]

A more complex dataset layout might contain a sub-list, say list of medication, which
is enabled by a flag which is part of the dataset. The name
of the flag, which is a variable in the dataset, must be given as showFlag, the value
where list is to be filled is the showFlagValue, and showQuery is the sublist query which will
be shown, as the following example shows:

![setup list example][setupListExample]

## Filling the form

Add a tab (Wheel->Page Admin Mode, click on a + tab). Add CRF Portal web part. This will show all forms that we will create. If the setup
worked, the Demographics form should appears in the CRF tab. 

[studyParameters]: img/studyParametersSnapshot.png
[exampleList]: img/exampleListSnapshot.png
[listArchive]: setup/initialLists.zip
[labkeyEnableModule]: https://www.labkey.org/Documentation/wiki-page.view?name=enableModuleInFolder
[setupList]: img/setupList.png
[setupListExample]: img/exampleSetupList.png
[setupListExample1]: img/exampleSetupList1.png
